package common;

import java.util.Vector;

public class Request {
    private ProcedureID procedure;
    private Vector<Double> params;

    public Request() {

    }

    public Request(ProcedureID procedureID) {
        procedure = procedureID;
        params = new Vector<>();
    }

    public Request(ProcedureID procedureID, double a, double b) {
        this(procedureID);
        params.add(a);
        params.add(b);
    }

    public ProcedureID getProcedure() { return procedure; }

    public void setProcedureID(ProcedureID procedureID) { procedure = procedureID; }

    public Vector<Double> getParams() {
        return params;
    }

    public void setParams(Vector<Double> params) {
        this.params = params;
    }

    public void setParam(int i, double x) {
        params.set(i, x);
    }

    public double getParam(int i) {
        return params.get(i);
    }

    public int paramsSize() {
        return params.size();
    }
}
