package client;

import common.*;

import java.io.IOException;
import java.net.Socket;

public class ClientStub implements IRPCProcedures {
    private final static String SERVER_ADDRESS = "localhost";
    private final static int RPC_PORT = 1234;

    @Override
    public double add(double a, double b) {
        return do_rpc(new Request(ProcedureID.addID, a, b));
    }

    @Override
    public double sub(double a, double b) {
        return do_rpc(new Request(ProcedureID.subID, a, b));
    }

    private double do_rpc(Request request) {
        Socket socket = null;
        Codec codec = null;
        try {
            socket = new Socket(SERVER_ADDRESS, RPC_PORT);
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("Server not available");
            System.exit(2);
        }
        try {
            //codec = new JsonCodec(socket);
            codec = new BinaryCodec(socket);
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("Streams broken");
            System.exit(2);
        }

        codec.sendRequest(request);

        double response = codec.fetchResponse();

        try {
            socket.close();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return response;
    }
}


